
/* File:        org.molgenis.omx/model/Category.java
 * Generator:   org.molgenis.generators.DataTypeGen 4.0.0-testing
 *
 * THIS FILE HAS BEEN GENERATED, PLEASE DO NOT EDIT!
 */
 

package org.molgenis.omx.observ;

/**
 * Category: Category is partOf ObservableFeature to define
				categories for an
				ObservableFeature, such as the categorical
				answer codes that are often used in Questionaires. 
				For example the ObservableFeature 'sex' has
				{code_string = 1, label=male} and {code_string
				= 2, label=female}.
				Category can be linked to well-defined
				ontology terms via the
				ontologyReference. Category
				extends
				ObservationElement such that it
				can be referenced by
				ObservedValue.value.
				The Category class maps to
				METABASE::Category
			.
 * @author MOLGENIS generator
 */
@javax.persistence.Entity
//@org.hibernate.search.annotations.Indexed
@javax.persistence.Table(name = "Category"
)

@javax.xml.bind.annotation.XmlAccessorType(javax.xml.bind.annotation.XmlAccessType.FIELD)
//@EntityListeners({org.molgenis.omx.observ.db.CategoryEntityListener.class})
public class Category extends org.molgenis.omx.observ.Characteristic 
{
    /** default serial version ID */
    private static final long serialVersionUID = 1L;
	// fieldname constants
	public final static String OBSERVABLEFEATURE = "observableFeature";
	public final static String OBSERVABLEFEATURE_IDENTIFIER = "observableFeature_Identifier";
	public final static String VALUECODE = "valueCode";
	public final static String DEFINITION = "definition";
	public final static String DEFINITION_IDENTIFIER = "definition_Identifier";
	public final static String ISMISSING = "isMissing";
	public final static String ID = "id";
	
	//static methods
	/**
	 * Shorthand for db.query(Category.class).
	 */
	public static org.molgenis.framework.db.Query<? extends Category> query(org.molgenis.framework.db.Database db)
	{
		return db.query(Category.class);
	}
	
	/**
	 * Shorthand for db.find(Category.class, org.molgenis.framework.db.QueryRule ... rules).
	 */
	public static java.util.List<? extends Category> find(org.molgenis.framework.db.Database db, org.molgenis.framework.db.QueryRule ... rules) throws org.molgenis.framework.db.DatabaseException
	{
		return db.find(Category.class, rules);
	}	
	
	/**
	 * 
	 */
	public static Category findById(org.molgenis.framework.db.Database db, Integer id) throws org.molgenis.framework.db.DatabaseException
	{
		org.molgenis.framework.db.Query<Category> q = db.query(Category.class);
		q.eq(Category.ID, id);
		java.util.List<Category> result = q.find();
		if(result.size()>0) return result.get(0);
		else return null;
	}

	/**
	 * 
	 */
	public static Category findByIdentifier(org.molgenis.framework.db.Database db, String identifier) throws org.molgenis.framework.db.DatabaseException
	{
		org.molgenis.framework.db.Query<Category> q = db.query(Category.class);
		q.eq(Category.IDENTIFIER, identifier);
		java.util.List<Category> result = q.find();
		if(result.size()>0) return result.get(0);
		else return null;
	}

	
	// member variables (including setters.getters for interface)

	//The Measurement these permitted values are part of.[type=xref]
    @javax.persistence.ManyToOne(fetch=javax.persistence.FetchType.EAGER /*cascade={javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH}*/)
    @javax.persistence.JoinColumn(name="observableFeature", nullable=false)   	
	
				

	@javax.validation.constraints.NotNull
	private org.molgenis.omx.observ.ObservableFeature observableFeature = null;
	@javax.persistence.Transient
	private Integer observableFeature_id = null;	
	@javax.persistence.Transient
	private String observableFeature_Identifier = null;						

	//The value used to store this category in ObservedValue. For example '1', '2'.[type=string]
	@javax.persistence.Column(name="valueCode", length=255)
	@javax.xml.bind.annotation.XmlElement(name="valueCode")
	
				

	private String valueCode =  null;

	//The category that is being measured in a specific way.[type=xref]
    @javax.persistence.ManyToOne(fetch=javax.persistence.FetchType.EAGER /*cascade={javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH}*/)
    @javax.persistence.JoinColumn(name="definition")   	
	
				

	private org.molgenis.omx.observ.target.OntologyTerm definition = null;
	@javax.persistence.Transient
	private Integer definition_id = null;	
	@javax.persistence.Transient
	private String definition_Identifier = null;						

	//whether this value should be treated as missing value.[type=bool]
	@javax.persistence.Column(name="isMissing", nullable=false)
	@javax.xml.bind.annotation.XmlElement(name="isMissing")
	
				

	@javax.validation.constraints.NotNull
	private Boolean isMissing =  false;

	//automatically generated internal id, only for internal use.[type=int]
	

	//constructors
	public Category()
	{
		//set the type for a new instance
		set__Type(this.getClass().getSimpleName());
	}
	
	/** copy constructor */
	public Category(Category copyMe) throws Exception
	{	
		for(String f : this.getFields())
		{
			this.set(f, copyMe.get(f));
		}	
	}
	
	//getters and setters
	/**
	 * Get the The Measurement these permitted values are part of..
	 * @return observableFeature.
	 */
	public org.molgenis.omx.observ.ObservableFeature getObservableFeature()
	{
		return this.observableFeature;
	}
	
	@Deprecated
	public org.molgenis.omx.observ.ObservableFeature getObservableFeature(org.molgenis.framework.db.Database db)
	{
		throw new UnsupportedOperationException();
	}	
	
	/**
	 * Set the The Measurement these permitted values are part of..
	 * @param observableFeature
	 */
	public void setObservableFeature( org.molgenis.omx.observ.ObservableFeature observableFeature)
	{
		
		this.observableFeature = observableFeature;
	}

	
	
	/**
	 * Set foreign key for field observableFeature.
	 * This will erase any foreign key objects currently set.
	 * FIXME: can we autoload the new object?
	 */
	public void setObservableFeature_Id(Integer observableFeature_id)
	{
		this.observableFeature_id = observableFeature_id;
	}	

	public void setObservableFeature(Integer observableFeature_id)
	{
		this.observableFeature_id = observableFeature_id;
	}
	
	public Integer getObservableFeature_Id()
	{
		
		if(observableFeature != null) 
		{
			return observableFeature.getId();
		}
		else
		{
			return observableFeature_id;
		}
	}	
	 
	/**
	 * Get a pretty label Identifier for cross reference ObservableFeature to ObservableFeature.Id.
	 */
	public String getObservableFeature_Identifier()
	{		
		//FIXME should we auto-load based on getObservableFeature()?	
		if(observableFeature != null) {
			return observableFeature.getIdentifier();
		} else {
			return observableFeature_Identifier;
		}
	}		
	
	/**
	 * Set a pretty label for cross reference ObservableFeature to <a href="ObservableFeature.html#Id">ObservableFeature.Id</a>.
	 * Implies setObservableFeature(null) until save
	 */
	public void setObservableFeature_Identifier(String observableFeature_Identifier)
	{
		this.observableFeature_Identifier = observableFeature_Identifier;
	}		
	 
	

	/**
	 * Get the The value used to store this category in ObservedValue. For example '1', '2'..
	 * @return valueCode.
	 */
	public String getValueCode()
	{
		return this.valueCode;
	}
	
	@Deprecated
	public String getValueCode(org.molgenis.framework.db.Database db)
	{
		throw new UnsupportedOperationException();
	}	
	
	/**
	 * Set the The value used to store this category in ObservedValue. For example '1', '2'..
	 * @param valueCode
	 */
	public void setValueCode( String valueCode)
	{
		
		this.valueCode = valueCode;
	}

	

	/**
	 * Get the The category that is being measured in a specific way..
	 * @return definition.
	 */
	public org.molgenis.omx.observ.target.OntologyTerm getDefinition()
	{
		return this.definition;
	}
	
	@Deprecated
	public org.molgenis.omx.observ.target.OntologyTerm getDefinition(org.molgenis.framework.db.Database db)
	{
		throw new UnsupportedOperationException();
	}	
	
	/**
	 * Set the The category that is being measured in a specific way..
	 * @param definition
	 */
	public void setDefinition( org.molgenis.omx.observ.target.OntologyTerm definition)
	{
		
		this.definition = definition;
	}

	
	
	/**
	 * Set foreign key for field definition.
	 * This will erase any foreign key objects currently set.
	 * FIXME: can we autoload the new object?
	 */
	public void setDefinition_Id(Integer definition_id)
	{
		this.definition_id = definition_id;
	}	

	public void setDefinition(Integer definition_id)
	{
		this.definition_id = definition_id;
	}
	
	public Integer getDefinition_Id()
	{
		
		if(definition != null) 
		{
			return definition.getId();
		}
		else
		{
			return definition_id;
		}
	}	
	 
	/**
	 * Get a pretty label Identifier for cross reference Definition to OntologyTerm.Id.
	 */
	public String getDefinition_Identifier()
	{		
		//FIXME should we auto-load based on getDefinition()?	
		if(definition != null) {
			return definition.getIdentifier();
		} else {
			return definition_Identifier;
		}
	}		
	
	/**
	 * Set a pretty label for cross reference Definition to <a href="OntologyTerm.html#Id">OntologyTerm.Id</a>.
	 * Implies setDefinition(null) until save
	 */
	public void setDefinition_Identifier(String definition_Identifier)
	{
		this.definition_Identifier = definition_Identifier;
	}		
	 
	

	/**
	 * Get the whether this value should be treated as missing value..
	 * @return isMissing.
	 */
	public Boolean getIsMissing()
	{
		return this.isMissing;
	}
	
	@Deprecated
	public Boolean getIsMissing(org.molgenis.framework.db.Database db)
	{
		throw new UnsupportedOperationException();
	}	
	
	/**
	 * Set the whether this value should be treated as missing value..
	 * @param isMissing
	 */
	public void setIsMissing( Boolean isMissing)
	{
		
		this.isMissing = isMissing;
	}

	

	

	


	/**
	 * Generic getter. Get the property by using the name.
	 */
	@Override
	public Object get(String name)
	{
		name = name.toLowerCase();
		if (name.equals("id"))
			return getId();
		if (name.equals("identifier"))
			return getIdentifier();
		if (name.equals("name"))
			return getName();
		if (name.equals("__type"))
			return get__Type();
		if(name.equals("__type_label"))
			return get__TypeLabel();
		if (name.equals("description"))
			return getDescription();
		if (name.equals("observablefeature"))
			return getObservableFeature();
		if(name.equals("observablefeature_id"))
			return getObservableFeature_Id();
		if(name.equals("observablefeature_identifier"))
			return getObservableFeature_Identifier();
		if (name.equals("valuecode"))
			return getValueCode();
		if (name.equals("definition"))
			return getDefinition();
		if(name.equals("definition_id"))
			return getDefinition_Id();
		if(name.equals("definition_identifier"))
			return getDefinition_Identifier();
		if (name.equals("ismissing"))
			return getIsMissing();
		return null;
	}	
	
	@Override
	public void validate() throws org.molgenis.framework.db.DatabaseException
	{
		if(this.getId() == null) throw new org.molgenis.framework.db.DatabaseException("required field id is null");
		if(this.getIdentifier() == null) throw new org.molgenis.framework.db.DatabaseException("required field identifier is null");
		if(this.getName() == null) throw new org.molgenis.framework.db.DatabaseException("required field name is null");
		if(this.get__Type() == null) throw new org.molgenis.framework.db.DatabaseException("required field __Type is null");
		if(this.getObservableFeature() == null) throw new org.molgenis.framework.db.DatabaseException("required field observableFeature is null");
		if(this.getIsMissing() == null) throw new org.molgenis.framework.db.DatabaseException("required field isMissing is null");
	}
	
	@Override
	public void set(org.molgenis.util.tuple.Tuple tuple, boolean strict ) throws Exception
	{
		//set Id
		// query formal name, else lowercase name
		if(tuple.getInt("id") != null) this.setId(tuple.getInt("id"));
		else if(tuple.getInt("id") != null) this.setId(tuple.getInt("id"));
		else if(strict) this.setId(tuple.getInt("id")); // setting null is not an option due to function overloading
		if( tuple.getInt("category_id") != null) this.setId(tuple.getInt("category_id"));
		else if( tuple.getInt("Category_id") != null) this.setId(tuple.getInt("Category_id"));
		//set Identifier
		// query formal name, else lowercase name
		if(tuple.getString("identifier") != null) this.setIdentifier(tuple.getString("identifier"));
		else if(tuple.getString("Identifier") != null) this.setIdentifier(tuple.getString("Identifier"));
		else if(strict) this.setIdentifier(tuple.getString("identifier")); // setting null is not an option due to function overloading
		if( tuple.getString("category_identifier") != null) this.setIdentifier(tuple.getString("category_identifier"));
		else if( tuple.getString("Category_Identifier") != null) this.setIdentifier(tuple.getString("Category_Identifier"));
		//set Name
		// query formal name, else lowercase name
		if(tuple.getString("name") != null) this.setName(tuple.getString("name"));
		else if(tuple.getString("Name") != null) this.setName(tuple.getString("Name"));
		else if(strict) this.setName(tuple.getString("name")); // setting null is not an option due to function overloading
		if( tuple.getString("category_name") != null) this.setName(tuple.getString("category_name"));
		else if( tuple.getString("Category_Name") != null) this.setName(tuple.getString("Category_Name"));
		//set __Type
		// query formal name, else lowercase name
		if(tuple.getString("__type") != null) this.set__Type(tuple.getString("__type"));
		else if(tuple.getString("__Type") != null) this.set__Type(tuple.getString("__Type"));
		else if(strict) this.set__Type(tuple.getString("__type")); // setting null is not an option due to function overloading
		if( tuple.getString("category___type") != null) this.set__Type(tuple.getString("category___type"));
		else if( tuple.getString("Category___Type") != null) this.set__Type(tuple.getString("Category___Type"));
		//set Description
		// query formal name, else lowercase name
		if(tuple.getString("description") != null) this.setDescription(tuple.getString("description"));
		else if(tuple.getString("description") != null) this.setDescription(tuple.getString("description"));
		else if(strict) this.setDescription(tuple.getString("description")); // setting null is not an option due to function overloading
		if( tuple.getString("category_description") != null) this.setDescription(tuple.getString("category_description"));
		else if( tuple.getString("Category_description") != null) this.setDescription(tuple.getString("Category_description"));
		//set ObservableFeature
		// query formal name, else lowercase name
		if(tuple.getInt("observableFeature_id") != null) this.setObservableFeature(tuple.getInt("observableFeature_id"));
		else if(tuple.getInt("observablefeature_id") != null) this.setObservableFeature(tuple.getInt("observablefeature_id"));
		else if(strict) this.setObservableFeature(tuple.getInt("observableFeature_id")); // setting null is not an option due to function overloading
		
		if( tuple.getInt("Category_observableFeature_id") != null) this.setObservableFeature(tuple.getInt("Category_observableFeature_id"));
		else if( tuple.getInt("category_observablefeature_id") != null) this.setObservableFeature(tuple.getInt("category_observablefeature_id"));
		//alias of xref
		if( tuple.get("observableFeature") != null) { 
			if(org.molgenis.util.AbstractEntity.isObjectRepresentation(tuple.get("observableFeature").toString())) {
				org.molgenis.omx.observ.ObservableFeature instance = org.molgenis.util.AbstractEntity.setValuesFromString((String)tuple.get("observableFeature"), org.molgenis.omx.observ.ObservableFeature.class);
				this.setObservableFeature(instance);				
			} else {
				this.setObservableFeature_Id(tuple.getInt("observableFeature")); 
			}
		}
		else if( tuple.get("observablefeature") != null) { 
			if(org.molgenis.util.AbstractEntity.isObjectRepresentation(tuple.get("observablefeature").toString())) {
				org.molgenis.omx.observ.ObservableFeature instance = org.molgenis.util.AbstractEntity.setValuesFromString((String)tuple.get("observablefeature"), org.molgenis.omx.observ.ObservableFeature.class);
				this.setObservableFeature(instance);				
			} else {
				this.setObservableFeature_Id(tuple.getInt("observableFeature"));
			}
		}
		if( tuple.get("Category_observableFeature") != null)
			this.setObservableFeature_Id(tuple.getInt("Category_observableFeature"));			
		else if( tuple.get("category_observablefeature") != null)
			this.setObservableFeature_Id(tuple.getInt("category_observablefeature"));
			
		if( tuple.get("Category.observableFeature") != null) 
			this.setObservableFeature((org.molgenis.omx.observ.ObservableFeature)tuple.get("Category.observableFeature_id"));
		else if( tuple.get("category.observablefeature") != null) 
			this.setObservableFeature((org.molgenis.omx.observ.ObservableFeature)tuple.get("category.observablefeature_id"));	
		//set label for field ObservableFeature
		if(tuple.get("observableFeature_Identifier") != null) this.setObservableFeature_Identifier(tuple.getString("observableFeature_Identifier"));
		else if(tuple.get("observablefeature_identifier") != null) this.setObservableFeature_Identifier(tuple.getString("observablefeature_identifier"));
		else if(strict) this.setObservableFeature_Identifier(tuple.getString("observableFeature_Identifier")); // setting null is not an option due to function overloading
		if( tuple.get("Category_observableFeature_Identifier") != null ) this.setObservableFeature_Identifier(tuple.getString("Category_observableFeature_Identifier"));		
		else if( tuple.get("category_observablefeature_identifier") != null ) this.setObservableFeature_Identifier(tuple.getString("category_observablefeature_identifier"));
		//set ValueCode
		// query formal name, else lowercase name
		if(tuple.getString("valuecode") != null) this.setValueCode(tuple.getString("valuecode"));
		else if(tuple.getString("valueCode") != null) this.setValueCode(tuple.getString("valueCode"));
		else if(strict) this.setValueCode(tuple.getString("valuecode")); // setting null is not an option due to function overloading
		if( tuple.getString("category_valuecode") != null) this.setValueCode(tuple.getString("category_valuecode"));
		else if( tuple.getString("Category_valueCode") != null) this.setValueCode(tuple.getString("Category_valueCode"));
		//set Definition
		// query formal name, else lowercase name
		if(tuple.getInt("definition_id") != null) this.setDefinition(tuple.getInt("definition_id"));
		else if(tuple.getInt("definition_id") != null) this.setDefinition(tuple.getInt("definition_id"));
		else if(strict) this.setDefinition(tuple.getInt("definition_id")); // setting null is not an option due to function overloading
		
		if( tuple.getInt("Category_definition_id") != null) this.setDefinition(tuple.getInt("Category_definition_id"));
		else if( tuple.getInt("category_definition_id") != null) this.setDefinition(tuple.getInt("category_definition_id"));
		//alias of xref
		if( tuple.get("definition") != null) { 
			if(org.molgenis.util.AbstractEntity.isObjectRepresentation(tuple.get("definition").toString())) {
				org.molgenis.omx.observ.target.OntologyTerm instance = org.molgenis.util.AbstractEntity.setValuesFromString((String)tuple.get("definition"), org.molgenis.omx.observ.target.OntologyTerm.class);
				this.setDefinition(instance);				
			} else {
				this.setDefinition_Id(tuple.getInt("definition")); 
			}
		}
		else if( tuple.get("definition") != null) { 
			if(org.molgenis.util.AbstractEntity.isObjectRepresentation(tuple.get("definition").toString())) {
				org.molgenis.omx.observ.target.OntologyTerm instance = org.molgenis.util.AbstractEntity.setValuesFromString((String)tuple.get("definition"), org.molgenis.omx.observ.target.OntologyTerm.class);
				this.setDefinition(instance);				
			} else {
				this.setDefinition_Id(tuple.getInt("definition"));
			}
		}
		if( tuple.get("Category_definition") != null)
			this.setDefinition_Id(tuple.getInt("Category_definition"));			
		else if( tuple.get("category_definition") != null)
			this.setDefinition_Id(tuple.getInt("category_definition"));
			
		if( tuple.get("Category.definition") != null) 
			this.setDefinition((org.molgenis.omx.observ.target.OntologyTerm)tuple.get("Category.definition_id"));
		else if( tuple.get("category.definition") != null) 
			this.setDefinition((org.molgenis.omx.observ.target.OntologyTerm)tuple.get("category.definition_id"));	
		//set label for field Definition
		if(tuple.get("definition_Identifier") != null) this.setDefinition_Identifier(tuple.getString("definition_Identifier"));
		else if(tuple.get("definition_identifier") != null) this.setDefinition_Identifier(tuple.getString("definition_identifier"));
		else if(strict) this.setDefinition_Identifier(tuple.getString("definition_Identifier")); // setting null is not an option due to function overloading
		if( tuple.get("Category_definition_Identifier") != null ) this.setDefinition_Identifier(tuple.getString("Category_definition_Identifier"));		
		else if( tuple.get("category_definition_identifier") != null ) this.setDefinition_Identifier(tuple.getString("category_definition_identifier"));
		//set IsMissing
		// query formal name, else lowercase name
		if(tuple.getBoolean("ismissing") != null) this.setIsMissing(tuple.getBoolean("ismissing"));
		else if(tuple.getBoolean("isMissing") != null) this.setIsMissing(tuple.getBoolean("isMissing"));
		else if(strict) this.setIsMissing(tuple.getBoolean("ismissing")); // setting null is not an option due to function overloading
		if( tuple.getBoolean("category_ismissing") != null) this.setIsMissing(tuple.getBoolean("category_ismissing"));
		else if( tuple.getBoolean("Category_isMissing") != null) this.setIsMissing(tuple.getBoolean("Category_isMissing"));
	}

	@Override
	public String toString()
	{
		return this.toString(false);
	}
	
	public String toString(boolean verbose)
	{
		String result = "Category(";
		result+= "id='" + getId()+"' ";	
		result+= "identifier='" + getIdentifier()+"' ";	
		result+= "name='" + getName()+"' ";	
		result+= "__Type='" + get__Type()+"' ";	
		result+= "description='" + getDescription()+"' ";	
		result+= " observableFeature_id='" + getObservableFeature_Id()+"' ";	
		result+= " observableFeature_identifier='" + getObservableFeature_Identifier()+"' ";
		result+= "valueCode='" + getValueCode()+"' ";	
		result+= " definition_id='" + getDefinition_Id()+"' ";	
		result+= " definition_identifier='" + getDefinition_Identifier()+"' ";
		result+= "isMissing='" + getIsMissing()+"'";	
		result += ");";
		return result;

	}

	/**
	 * Get the names of all public properties of Category.
	 */
	@Override
	public java.util.Vector<String> getFields(boolean skipAutoIds)
	{
		java.util.Vector<String> fields = new java.util.Vector<String>();
		if(!skipAutoIds)
		{
			fields.add("id");
		}
		{
			fields.add("Identifier");
		}
		{
			fields.add("Name");
		}
		{
			fields.add("__Type");
		}
		{
			fields.add("description");
		}
		{
			fields.add("observableFeature_id");
		}
		fields.add("observableFeature_Identifier");
		{
			fields.add("valueCode");
		}
		{
			fields.add("definition_id");
		}
		fields.add("definition_Identifier");
		{
			fields.add("isMissing");
		}
		return fields;
	}	

	@Override
	public java.util.Vector<String> getFields()
	{
		return getFields(false);
	}

	@Override
	public String getIdField()
	{
		return "id";
	}

	@Override
	public java.util.List<String> getLabelFields()
	{
		java.util.List<String> result = new java.util.ArrayList<String>();
		result.add("Identifier");
		return result;
	}

	@Deprecated
	@Override
	public String getFields(String sep)
	{
		return (""
		+ "id" +sep
		+ "identifier" +sep
		+ "name" +sep
		+ "__Type" +sep
		+ "description" +sep
		+ "observableFeature" +sep
		+ "valueCode" +sep
		+ "definition" +sep
		+ "isMissing" 
		);
	}

	@Override
	public Object getIdValue()
	{
		return get(getIdField());
	}		
	
	@Override
    public String getXrefIdFieldName(String fieldName) {
        if (fieldName.equalsIgnoreCase("observableFeature")) {
            return "id";
        }
        if (fieldName.equalsIgnoreCase("definition")) {
            return "id";
        }
        
        return null;
    }	

	@Deprecated
	@Override
	public String getValues(String sep)
	{
		java.io.StringWriter out = new java.io.StringWriter();
		{
			Object valueO = getId();
			String valueS;
			if (valueO != null)
				valueS = valueO.toString();
			else 
				valueS = "";
			valueS = valueS.replaceAll("\r\n"," ").replaceAll("\n"," ").replaceAll("\r"," ");
			valueS = valueS.replaceAll("\t"," ").replaceAll(sep," ");
			out.write(valueS+sep);
		}
		{
			Object valueO = getIdentifier();
			String valueS;
			if (valueO != null)
				valueS = valueO.toString();
			else 
				valueS = "";
			valueS = valueS.replaceAll("\r\n"," ").replaceAll("\n"," ").replaceAll("\r"," ");
			valueS = valueS.replaceAll("\t"," ").replaceAll(sep," ");
			out.write(valueS+sep);
		}
		{
			Object valueO = getName();
			String valueS;
			if (valueO != null)
				valueS = valueO.toString();
			else 
				valueS = "";
			valueS = valueS.replaceAll("\r\n"," ").replaceAll("\n"," ").replaceAll("\r"," ");
			valueS = valueS.replaceAll("\t"," ").replaceAll(sep," ");
			out.write(valueS+sep);
		}
		{
			Object valueO = get__Type();
			String valueS;
			if (valueO != null)
				valueS = valueO.toString();
			else 
				valueS = "";
			valueS = valueS.replaceAll("\r\n"," ").replaceAll("\n"," ").replaceAll("\r"," ");
			valueS = valueS.replaceAll("\t"," ").replaceAll(sep," ");
			out.write(valueS+sep);
		}
		{
			Object valueO = getDescription();
			String valueS;
			if (valueO != null)
				valueS = valueO.toString();
			else 
				valueS = "";
			valueS = valueS.replaceAll("\r\n"," ").replaceAll("\n"," ").replaceAll("\r"," ");
			valueS = valueS.replaceAll("\t"," ").replaceAll(sep," ");
			out.write(valueS+sep);
		}
		{
			Object valueO = getObservableFeature();
			String valueS;
			if (valueO != null)
				valueS = valueO.toString();
			else 
				valueS = "";
			valueS = valueS.replaceAll("\r\n"," ").replaceAll("\n"," ").replaceAll("\r"," ");
			valueS = valueS.replaceAll("\t"," ").replaceAll(sep," ");
			out.write(valueS+sep);
		}
		{
			Object valueO = getValueCode();
			String valueS;
			if (valueO != null)
				valueS = valueO.toString();
			else 
				valueS = "";
			valueS = valueS.replaceAll("\r\n"," ").replaceAll("\n"," ").replaceAll("\r"," ");
			valueS = valueS.replaceAll("\t"," ").replaceAll(sep," ");
			out.write(valueS+sep);
		}
		{
			Object valueO = getDefinition();
			String valueS;
			if (valueO != null)
				valueS = valueO.toString();
			else 
				valueS = "";
			valueS = valueS.replaceAll("\r\n"," ").replaceAll("\n"," ").replaceAll("\r"," ");
			valueS = valueS.replaceAll("\t"," ").replaceAll(sep," ");
			out.write(valueS+sep);
		}
		{
			Object valueO = getIsMissing();
			String valueS;
			if (valueO != null)
				valueS = valueO.toString();
			else 
				valueS = "";
			valueS = valueS.replaceAll("\r\n"," ").replaceAll("\n"," ").replaceAll("\r"," ");
			valueS = valueS.replaceAll("\t"," ").replaceAll(sep," ");
			out.write(valueS);
		}
		return out.toString();
	}
	
	@Override
	public Category create(org.molgenis.util.tuple.Tuple tuple) throws Exception
	{
		Category e = new Category();
		e.set(tuple);
		return e;
	}
	

	@Override
	public boolean equals(Object obj)
	{
		if (this == obj) return true;
		if (obj == null) return false;
		if (!super.equals(obj)) return false;
		if (getClass() != obj.getClass()) return false;
		return true;
	}
	
	@Override
	public int hashCode()
	{
		int result = super.hashCode();
		return result;
	}
}
