
/* File:        org.molgenis.omx/model/Characteristic.java
 * Generator:   org.molgenis.generators.DataTypeGen 4.0.0-testing
 *
 * THIS FILE HAS BEEN GENERATED, PLEASE DO NOT EDIT!
 */
 

package org.molgenis.omx.observ;

/**
 * Characteristic:  Characteristics are yes-no
				statements about things in
				the world. These can be used as part of an observation, as
				parameter
				of ObservableFeature ('measuredCharacteristic'). For
				example: 'What
				is allele of [Marker]', here the [Marker] is a
				characteristic. Also,
				Characteristics can be used as target of
				observation. Typical
				examples are 'Individual' or 'Panel'. But also
				'Marker' can be an
				Target when asked the question 'QTL p-value for
				[phenotype]': here
				both target and feature are characteristic, for
				example 'leave count'
				(phenotype characteristic) and 'PVV4' (marker
				characteristic).
			.
 * @author MOLGENIS generator
 */
@javax.persistence.Entity
//@org.hibernate.search.annotations.Indexed
@javax.persistence.Table(name = "Characteristic", uniqueConstraints={ @javax.persistence.UniqueConstraint( columnNames={ "Identifier" } ) }
)

@javax.persistence.Inheritance(strategy=javax.persistence.InheritanceType.JOINED)
@javax.persistence.DiscriminatorColumn(name="DType", discriminatorType=javax.persistence.DiscriminatorType.STRING)
@javax.xml.bind.annotation.XmlAccessorType(javax.xml.bind.annotation.XmlAccessType.FIELD)
//@EntityListeners({org.molgenis.omx.observ.db.CharacteristicEntityListener.class})
public class Characteristic extends org.molgenis.util.AbstractEntity implements org.molgenis.omx.core.Identifiable
{
    /** default serial version ID */
    private static final long serialVersionUID = 1L;
	// fieldname constants
	public final static String ID = "id";
	public final static String IDENTIFIER = "Identifier";
	public final static String NAME = "Name";
	public final static String __TYPE = "__Type";
	public final static String DESCRIPTION = "description";
	
	//static methods
	/**
	 * Shorthand for db.query(Characteristic.class).
	 */
	public static org.molgenis.framework.db.Query<? extends Characteristic> query(org.molgenis.framework.db.Database db)
	{
		return db.query(Characteristic.class);
	}
	
	/**
	 * Shorthand for db.find(Characteristic.class, org.molgenis.framework.db.QueryRule ... rules).
	 */
	public static java.util.List<? extends Characteristic> find(org.molgenis.framework.db.Database db, org.molgenis.framework.db.QueryRule ... rules) throws org.molgenis.framework.db.DatabaseException
	{
		return db.find(Characteristic.class, rules);
	}	
	
	/**
	 * 
	 */
	public static Characteristic findById(org.molgenis.framework.db.Database db, Integer id) throws org.molgenis.framework.db.DatabaseException
	{
		org.molgenis.framework.db.Query<Characteristic> q = db.query(Characteristic.class);
		q.eq(Characteristic.ID, id);
		java.util.List<Characteristic> result = q.find();
		if(result.size()>0) return result.get(0);
		else return null;
	}

	/**
	 * 
	 */
	public static Characteristic findByIdentifier(org.molgenis.framework.db.Database db, String identifier) throws org.molgenis.framework.db.DatabaseException
	{
		org.molgenis.framework.db.Query<Characteristic> q = db.query(Characteristic.class);
		q.eq(Characteristic.IDENTIFIER, identifier);
		java.util.List<Characteristic> result = q.find();
		if(result.size()>0) return result.get(0);
		else return null;
	}

	
	// member variables (including setters.getters for interface)

	//automatically generated internal id, only for internal use.[type=int]
    @javax.persistence.Id @javax.persistence.GeneratedValue(strategy = javax.persistence.GenerationType.AUTO)
    @javax.persistence.Column(name="id", nullable=false)
	@javax.xml.bind.annotation.XmlElement(name="id")
	
	//@javax.validation.constraints.NotNull
	private Integer id =  null;

	//user supplied or automatically assigned (using a decorator) unique and short identifier, e.g. MA1234[type=string]
//	@org.hibernate.search.annotations.Field(index=org.hibernate.search.annotations.Index.TOKENIZED, store=org.hibernate.search.annotations.Store.NO)
	@javax.persistence.Column(name="Identifier", length=255, nullable=false)
	@javax.xml.bind.annotation.XmlElement(name="identifier")
	
				

	@javax.validation.constraints.NotNull
	private String identifier =  null;

	//human readible name, not necessary unique.[type=string]
	@javax.persistence.Column(name="Name", length=255, nullable=false)
	@javax.xml.bind.annotation.XmlElement(name="name")
	
				

	@javax.validation.constraints.NotNull
	private String name =  null;

	//Subtypes have to be set to allow searching[type=enum]
	@javax.persistence.Column(name="DType", nullable=false)            
	@javax.xml.bind.annotation.XmlElement(name="__Type")
	
				

	@javax.validation.constraints.NotNull
	private String __Type =  null;
	@javax.persistence.Transient
	private String __Type_label = null;
	@javax.persistence.Transient
	private static final java.util.List<org.molgenis.util.ValueLabel> __Type_options;
	
	static {
		__Type_options = new java.util.ArrayList<org.molgenis.util.ValueLabel>();
		__Type_options.add(new org.molgenis.util.ValueLabel("Characteristic","Characteristic"));
		__Type_options.add(new org.molgenis.util.ValueLabel("Individual","Individual"));
		__Type_options.add(new org.molgenis.util.ValueLabel("Panel","Panel"));
		__Type_options.add(new org.molgenis.util.ValueLabel("ObservationTarget","ObservationTarget"));
		__Type_options.add(new org.molgenis.util.ValueLabel("ObservableFeature","ObservableFeature"));
		__Type_options.add(new org.molgenis.util.ValueLabel("Category","Category"));
		__Type_options.add(new org.molgenis.util.ValueLabel("Protocol","Protocol"));
		__Type_options.add(new org.molgenis.util.ValueLabel("DataSet","DataSet"));
		__Type_options.add(new org.molgenis.util.ValueLabel("Species","Species"));
		__Type_options.add(new org.molgenis.util.ValueLabel("Accession","Accession"));
		__Type_options.add(new org.molgenis.util.ValueLabel("OntologyTerm","OntologyTerm"));
	}

	//(Optional) Rudimentary meta data about the observable feature. Use of ontology       terms references to establish unambigious descriptions is recommended[type=text]
	@javax.persistence.Lob
	@javax.persistence.Column(name="description")
	
				

	private String description =  null;

	//constructors
	public Characteristic()
	{
		//set the type for a new instance
		set__Type(this.getClass().getSimpleName());
	}
	
	/** copy constructor */
	public Characteristic(Characteristic copyMe) throws Exception
	{	
		for(String f : this.getFields())
		{
			this.set(f, copyMe.get(f));
		}	
	}
	
	//getters and setters
	/**
	 * Get the automatically generated internal id, only for internal use..
	 * @return id.
	 */
	public Integer getId()
	{
		return this.id;
	}
	
	
	/**
	 * Set the automatically generated internal id, only for internal use..
	 * @param id
	 */
	public void setId( Integer id)
	{
		this.id = id;
	}

	

	/**
	 * Get the user supplied or automatically assigned (using a decorator) unique and short identifier, e.g. MA1234.
	 * @return identifier.
	 */
	public String getIdentifier()
	{
		return this.identifier;
	}
	
	@Deprecated
	public String getIdentifier(org.molgenis.framework.db.Database db)
	{
		throw new UnsupportedOperationException();
	}	
	
	/**
	 * Set the user supplied or automatically assigned (using a decorator) unique and short identifier, e.g. MA1234.
	 * @param identifier
	 */
	public void setIdentifier( String identifier)
	{
		
		this.identifier = identifier;
	}

	

	/**
	 * Get the human readible name, not necessary unique..
	 * @return name.
	 */
	public String getName()
	{
		return this.name;
	}
	
	@Deprecated
	public String getName(org.molgenis.framework.db.Database db)
	{
		throw new UnsupportedOperationException();
	}	
	
	/**
	 * Set the human readible name, not necessary unique..
	 * @param name
	 */
	public void setName( String name)
	{
		
		this.name = name;
	}

	

	/**
	 * Get the Subtypes have to be set to allow searching.
	 * @return __Type.
	 */
	public String get__Type()
	{
		return this.__Type;
	}
	
	@Deprecated
	public String get__Type(org.molgenis.framework.db.Database db)
	{
		throw new UnsupportedOperationException();
	}	
	
	/**
	 * Set the Subtypes have to be set to allow searching.
	 * @param __Type
	 */
	public void set__Type( String __Type)
	{
		
		this.__Type = __Type;
	}

	
	/**
	 * Get tha label for enum __Type.
	 */
	public String get__TypeLabel()
	{
		return this.__Type_label;
	}
	/**
	 * __Type is enum. This method returns all available enum options.
	 */
	public java.util.List<org.molgenis.util.ValueLabel> get__TypeOptions()
	{
		return __Type_options;
	}	
	

	/**
	 * Get the (Optional) Rudimentary meta data about the observable feature. Use of ontology       terms references to establish unambigious descriptions is recommended.
	 * @return description.
	 */
	public String getDescription()
	{
		return this.description;
	}
	
	@Deprecated
	public String getDescription(org.molgenis.framework.db.Database db)
	{
		throw new UnsupportedOperationException();
	}	
	
	/**
	 * Set the (Optional) Rudimentary meta data about the observable feature. Use of ontology       terms references to establish unambigious descriptions is recommended.
	 * @param description
	 */
	public void setDescription( String description)
	{
		
		this.description = description;
	}

	


	/**
	 * Generic getter. Get the property by using the name.
	 */
	@Override
	public Object get(String name)
	{
		name = name.toLowerCase();
		if (name.equals("id"))
			return getId();
		if (name.equals("identifier"))
			return getIdentifier();
		if (name.equals("name"))
			return getName();
		if (name.equals("__type"))
			return get__Type();
		if(name.equals("__type_label"))
			return get__TypeLabel();
		if (name.equals("description"))
			return getDescription();
		return null;
	}	
	
	@Override
	public void validate() throws org.molgenis.framework.db.DatabaseException
	{
		if(this.getId() == null) throw new org.molgenis.framework.db.DatabaseException("required field id is null");
		if(this.getIdentifier() == null) throw new org.molgenis.framework.db.DatabaseException("required field identifier is null");
		if(this.getName() == null) throw new org.molgenis.framework.db.DatabaseException("required field name is null");
		if(this.get__Type() == null) throw new org.molgenis.framework.db.DatabaseException("required field __Type is null");
	}
	
	@Override
	public void set(org.molgenis.util.tuple.Tuple tuple, boolean strict ) throws Exception
	{
		//set Id
		// query formal name, else lowercase name
		if(tuple.getInt("id") != null) this.setId(tuple.getInt("id"));
		else if(tuple.getInt("id") != null) this.setId(tuple.getInt("id"));
		else if(strict) this.setId(tuple.getInt("id")); // setting null is not an option due to function overloading
		if( tuple.getInt("characteristic_id") != null) this.setId(tuple.getInt("characteristic_id"));
		else if( tuple.getInt("Characteristic_id") != null) this.setId(tuple.getInt("Characteristic_id"));
		//set Identifier
		// query formal name, else lowercase name
		if(tuple.getString("identifier") != null) this.setIdentifier(tuple.getString("identifier"));
		else if(tuple.getString("Identifier") != null) this.setIdentifier(tuple.getString("Identifier"));
		else if(strict) this.setIdentifier(tuple.getString("identifier")); // setting null is not an option due to function overloading
		if( tuple.getString("characteristic_identifier") != null) this.setIdentifier(tuple.getString("characteristic_identifier"));
		else if( tuple.getString("Characteristic_Identifier") != null) this.setIdentifier(tuple.getString("Characteristic_Identifier"));
		//set Name
		// query formal name, else lowercase name
		if(tuple.getString("name") != null) this.setName(tuple.getString("name"));
		else if(tuple.getString("Name") != null) this.setName(tuple.getString("Name"));
		else if(strict) this.setName(tuple.getString("name")); // setting null is not an option due to function overloading
		if( tuple.getString("characteristic_name") != null) this.setName(tuple.getString("characteristic_name"));
		else if( tuple.getString("Characteristic_Name") != null) this.setName(tuple.getString("Characteristic_Name"));
		//set __Type
		// query formal name, else lowercase name
		if(tuple.getString("__type") != null) this.set__Type(tuple.getString("__type"));
		else if(tuple.getString("__Type") != null) this.set__Type(tuple.getString("__Type"));
		else if(strict) this.set__Type(tuple.getString("__type")); // setting null is not an option due to function overloading
		if( tuple.getString("characteristic___type") != null) this.set__Type(tuple.getString("characteristic___type"));
		else if( tuple.getString("Characteristic___Type") != null) this.set__Type(tuple.getString("Characteristic___Type"));
		//set Description
		// query formal name, else lowercase name
		if(tuple.getString("description") != null) this.setDescription(tuple.getString("description"));
		else if(tuple.getString("description") != null) this.setDescription(tuple.getString("description"));
		else if(strict) this.setDescription(tuple.getString("description")); // setting null is not an option due to function overloading
		if( tuple.getString("characteristic_description") != null) this.setDescription(tuple.getString("characteristic_description"));
		else if( tuple.getString("Characteristic_description") != null) this.setDescription(tuple.getString("Characteristic_description"));
	}

	@Override
	public String toString()
	{
		return this.toString(false);
	}
	
	public String toString(boolean verbose)
	{
		String result = "Characteristic(";
		result+= "id='" + getId()+"' ";	
		result+= "identifier='" + getIdentifier()+"' ";	
		result+= "name='" + getName()+"' ";	
		result+= "__Type='" + get__Type()+"' ";	
		result+= "description='" + getDescription()+"'";	
		result += ");";
		return result;

	}

	/**
	 * Get the names of all public properties of Characteristic.
	 */
	@Override
	public java.util.Vector<String> getFields(boolean skipAutoIds)
	{
		java.util.Vector<String> fields = new java.util.Vector<String>();
		if(!skipAutoIds)
		{
			fields.add("id");
		}
		{
			fields.add("Identifier");
		}
		{
			fields.add("Name");
		}
		{
			fields.add("__Type");
		}
		{
			fields.add("description");
		}
		return fields;
	}	

	@Override
	public java.util.Vector<String> getFields()
	{
		return getFields(false);
	}

	@Override
	public String getIdField()
	{
		return "id";
	}

	@Override
	public java.util.List<String> getLabelFields()
	{
		java.util.List<String> result = new java.util.ArrayList<String>();
		result.add("Identifier");
		return result;
	}

	@Deprecated
	@Override
	public String getFields(String sep)
	{
		return (""
		+ "id" +sep
		+ "identifier" +sep
		+ "name" +sep
		+ "__Type" +sep
		+ "description" 
		);
	}

	@Override
	public Object getIdValue()
	{
		return get(getIdField());
	}		
	
	@Override
    public String getXrefIdFieldName(String fieldName) {
        
        return null;
    }	

	@Deprecated
	@Override
	public String getValues(String sep)
	{
		java.io.StringWriter out = new java.io.StringWriter();
		{
			Object valueO = getId();
			String valueS;
			if (valueO != null)
				valueS = valueO.toString();
			else 
				valueS = "";
			valueS = valueS.replaceAll("\r\n"," ").replaceAll("\n"," ").replaceAll("\r"," ");
			valueS = valueS.replaceAll("\t"," ").replaceAll(sep," ");
			out.write(valueS+sep);
		}
		{
			Object valueO = getIdentifier();
			String valueS;
			if (valueO != null)
				valueS = valueO.toString();
			else 
				valueS = "";
			valueS = valueS.replaceAll("\r\n"," ").replaceAll("\n"," ").replaceAll("\r"," ");
			valueS = valueS.replaceAll("\t"," ").replaceAll(sep," ");
			out.write(valueS+sep);
		}
		{
			Object valueO = getName();
			String valueS;
			if (valueO != null)
				valueS = valueO.toString();
			else 
				valueS = "";
			valueS = valueS.replaceAll("\r\n"," ").replaceAll("\n"," ").replaceAll("\r"," ");
			valueS = valueS.replaceAll("\t"," ").replaceAll(sep," ");
			out.write(valueS+sep);
		}
		{
			Object valueO = get__Type();
			String valueS;
			if (valueO != null)
				valueS = valueO.toString();
			else 
				valueS = "";
			valueS = valueS.replaceAll("\r\n"," ").replaceAll("\n"," ").replaceAll("\r"," ");
			valueS = valueS.replaceAll("\t"," ").replaceAll(sep," ");
			out.write(valueS+sep);
		}
		{
			Object valueO = getDescription();
			String valueS;
			if (valueO != null)
				valueS = valueO.toString();
			else 
				valueS = "";
			valueS = valueS.replaceAll("\r\n"," ").replaceAll("\n"," ").replaceAll("\r"," ");
			valueS = valueS.replaceAll("\t"," ").replaceAll(sep," ");
			out.write(valueS);
		}
		return out.toString();
	}
	
	@Override
	public Characteristic create(org.molgenis.util.tuple.Tuple tuple) throws Exception
	{
		Characteristic e = new Characteristic();
		e.set(tuple);
		return e;
	}
	
	//3
    @javax.persistence.ManyToMany(fetch=javax.persistence.FetchType.LAZY, mappedBy="value"/*, cascade={javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH}*/)
    private java.util.Collection<org.molgenis.omx.observ.value.MrefValue> valueMrefValueCollection;

	@javax.xml.bind.annotation.XmlTransient
	public java.util.Collection<org.molgenis.omx.observ.value.MrefValue> getValueMrefValueCollection()
	{
		if(valueMrefValueCollection == null) valueMrefValueCollection = new java.util.ArrayList<org.molgenis.omx.observ.value.MrefValue>(); 
        return valueMrefValueCollection;
	}

	@javax.xml.bind.annotation.XmlTransient
	public java.util.Collection<org.molgenis.omx.observ.value.MrefValue> getValueMrefValueCollection(org.molgenis.framework.db.Database db)
	{
        return getValueMrefValueCollection();
	}

    public void setValueMrefValueCollection(java.util.Collection<org.molgenis.omx.observ.value.MrefValue> collection)
    {
		if(valueMrefValueCollection == null) valueMrefValueCollection = new java.util.ArrayList<org.molgenis.omx.observ.value.MrefValue>();
    	valueMrefValueCollection.addAll(collection);
    }	

	@Override
	public boolean equals(Object obj)
	{
		if (this == obj) return true;
		if (obj == null) return false;
		if (getClass() != obj.getClass()) return false;
		Characteristic other = (Characteristic) obj;
		if (identifier == null)
		{
			if (other.identifier != null) return false;
		}
		else if (!identifier.equals(other.identifier)) return false;
		return true;
	}
	
	@Override
	public int hashCode()
	{
		final int prime = 31;
		int result = 1;
		result = prime * result + ((identifier == null) ? 0 : identifier.hashCode());
		return result;
	}
}
