/* File:        org.molgenis.omx/model/ObservationSet.java
 * Copyright:   GBIC 2000-2,013, all rights reserved
 * Date:        August 21, 2013
 * Template:	JpaMapperGen.java.ftl
 * generator:   org.molgenis.generators.db.JpaMapperGen 4.0.0-testing
 *
 * Jpa Entity Mapper, helper to add, delete and update entities
 * 
 * THIS FILE HAS BEEN GENERATED, PLEASE DO NOT EDIT!
 */

package org.molgenis.omx.observ.db;

@edu.umd.cs.findbugs.annotations.SuppressWarnings(value = "DLS_DEAD_LOCAL_STORE", justification = "Too much template code required to prevent warnings")
public class ObservationSetJpaMapper extends org.molgenis.framework.db.jpa.AbstractJpaMapper<org.molgenis.omx.observ.ObservationSet>
{
	private final static org.apache.log4j.Logger log = org.apache.log4j.Logger.getLogger(ObservationSetJpaMapper.class);

	public ObservationSetJpaMapper(org.molgenis.framework.db.Database db) 
	{
		super(db);
	}
	
	@Override
	public String createFindSqlInclRules(org.molgenis.framework.db.QueryRule[] rules) throws org.molgenis.framework.db.DatabaseException
	{
		return "SELECT ObservationSet.id"
			+", ObservationSet.partOfDataSet"
			+", ObservationSet.Time"
			//parent is SimpleTree(name='partOfDataSet')
			+", xref_partOfDataSet.Identifier AS partOfDataSet_Identifier"
			+" FROM ObservationSet "

			
			//label for partOfDataSet=Identifier
//path==partOfDataSet. type==xref.
//path==partOfDataSet_Identifier. type==string.
//in if path.value.type != "xref" && !pathlist?seq_contains(path.getParent().name)
		   	+" LEFT JOIN Characteristic AS xref_partOfDataSet " 
			+" ON xref_partOfDataSet.id = ObservationSet.partOfDataSet"
;
	}	

	/** This method first saves the objects that are being refered to by entity, 
	then the entity itself and 
	finally the objects that refer to this object*/
    public void create(org.molgenis.omx.observ.ObservationSet entity) throws org.molgenis.framework.db.DatabaseException {
        try {


			//check if the object refered by 'partOfDataSet' is known in the databse
			if(entity.getPartOfDataSet() != null)
			{
				//if object has been added as xref, but not yet stored (has no id) -> add the refered object
				if(entity.getPartOfDataSet().getIdValue() == null)
					new org.molgenis.omx.observ.db.DataSetJpaMapper(getDatabase()).create(entity.getPartOfDataSet());
				//if object has id (so is stored) but not in this em -> retrieve proper reference reference
				else if (!getEntityManager().contains(entity.getPartOfDataSet()) && entity.getPartOfDataSet().getIdValue() != null)
					entity.setPartOfDataSet(getEntityManager().getReference(org.molgenis.omx.observ.DataSet.class, entity.getPartOfDataSet().getIdValue()));
			} else { //object is reference by xref	
				if(entity.getPartOfDataSet_Id() != null) {
					entity.setPartOfDataSet((org.molgenis.omx.observ.DataSet)getEntityManager().find(org.molgenis.omx.observ.DataSet.class, entity.getPartOfDataSet_Id()));
				}
			}

			//prevents uncontrolled recursion call of create (stack overflow)
          
          if(entity.getIdValue() != null) {
            entity = getEntityManager().merge(entity);            
          } else {
            getEntityManager().persist(entity);
          }
//inverse association relation

        } catch (Exception ex) {
            try {
				getEntityManager().getTransaction().rollback();
            } catch (Exception re) {
                throw new org.molgenis.framework.db.DatabaseException("An error occurred attempting to roll back the transaction: "+re.getMessage());
            }
            throw new org.molgenis.framework.db.DatabaseException(ex);
        }
    }

	public void destroy(org.molgenis.omx.observ.ObservationSet observationSet) throws org.molgenis.framework.db.DatabaseException {
		try {
			try {
				observationSet = getEntityManager().getReference(org.molgenis.omx.observ.ObservationSet.class, observationSet.getIdValue());
			} catch (javax.persistence.EntityNotFoundException enfe) {
				throw new org.molgenis.framework.db.DatabaseException("The observationSet with id " + observationSet.getIdField().toString() + " no longer exists: " + enfe.getMessage());
			}

			getEntityManager().remove(observationSet);
		} catch (Exception ex) {
			try {
				getEntityManager().getTransaction().rollback();
			} catch (Exception re) {
				throw new org.molgenis.framework.db.DatabaseException("An error occurred attempting to roll back the transaction: "+re.getMessage());
			}
			throw new org.molgenis.framework.db.DatabaseException(ex);
		} 
	}


	public void edit(org.molgenis.omx.observ.ObservationSet observationSet) throws org.molgenis.framework.db.DatabaseException {
		try {



			//1
			org.molgenis.omx.observ.DataSet partOfDataSetNew = observationSet.getPartOfDataSet();

			if (partOfDataSetNew == null) { //object is reference by xref		
                            if(observationSet.getPartOfDataSet_Id() != null) {
                                observationSet.setPartOfDataSet((org.molgenis.omx.observ.DataSet)getEntityManager().find(org.molgenis.omx.observ.DataSet.class, observationSet.getPartOfDataSet_Id()));
                            }
			}

			if(!getEntityManager().contains(observationSet)) {
				observationSet = getEntityManager().merge(observationSet);
			}
			

		} catch (Exception ex) {
			try {
				getEntityManager().getTransaction().rollback();
			} catch (Exception re) {
				throw new org.molgenis.framework.db.DatabaseException("An error occurred attempting to roll back the transaction: " + re.getMessage());
			}
			throw new org.molgenis.framework.db.DatabaseException(ex);
		} 
	}

	@Override
	public int executeAdd(java.util.List<? extends org.molgenis.omx.observ.ObservationSet> entities) throws org.molgenis.framework.db.DatabaseException
	{	
		int count = 0;
		
		try 
		{
			for (org.molgenis.omx.observ.ObservationSet observationSet : entities) 
			{
				create(observationSet);
				++count;
			}
		}
		catch (Exception ex) 
		{
            throw new org.molgenis.framework.db.DatabaseException(ex);
        }
		return count;
	}

	@Override
	public int executeUpdate(java.util.List<? extends org.molgenis.omx.observ.ObservationSet> entities) throws org.molgenis.framework.db.DatabaseException
	{
		int count = 0;

		try
		{
			for (org.molgenis.omx.observ.ObservationSet observationSet : entities) 
			{
				edit(observationSet);
				++count;
			} 
			return count;
		}
		catch (Exception ex) 
		{
            throw new org.molgenis.framework.db.DatabaseException(ex);
        }		
	}

	@Override
	public int executeRemove(java.util.List<? extends org.molgenis.omx.observ.ObservationSet> entities) throws org.molgenis.framework.db.DatabaseException
	{
		int count = 0;		
		try 
		{
			for (org.molgenis.omx.observ.ObservationSet observationSet : entities) 
			{
				destroy(observationSet);
				++count;
			}
		} 
		catch (Exception ex) 
		{
            throw new org.molgenis.framework.db.DatabaseException(ex);
        }
		return count;
	}
	
	@Override
	public String getTableFieldName(String fieldName)
	{
		if("id".equalsIgnoreCase(fieldName)) return "id";
		if("ObservationSet_id".equalsIgnoreCase(fieldName)) return "id";
		if("partOfDataSet".equalsIgnoreCase(fieldName)) return "partOfDataSet";
		if("ObservationSet_partOfDataSet".equalsIgnoreCase(fieldName)) return "partOfDataSet";
		if("Time".equalsIgnoreCase(fieldName)) return "Time";
		if("ObservationSet_Time".equalsIgnoreCase(fieldName)) return "Time";
		if("partOfDataSet_id".equalsIgnoreCase(fieldName)) return "partOfDataSet";
		if("ObservationSet_partOfDataSet_id".equalsIgnoreCase(fieldName)) return "partOfDataSet";
		if("partOfDataSet_Identifier".equalsIgnoreCase(fieldName)) return "partOfDataSet.Identifier";	
		if("ObservationSet_partOfDataSet_Identifier".equalsIgnoreCase(fieldName)) return "partOfDataSet.Identifier";
		return fieldName;
	}
	
	/**
	 * Return EMPTY list of given allocated size
	 *
	 * @param i initial capacity of returned EMPTY list
	 * @return an EMPTY list with initial capacity given by size
	 */
	@Override
	public java.util.List<org.molgenis.omx.observ.ObservationSet> createList(int size)
	{
		return new java.util.ArrayList<org.molgenis.omx.observ.ObservationSet>(size);
	}			

	@Override
	public org.molgenis.omx.observ.ObservationSet create()
	{
		return new org.molgenis.omx.observ.ObservationSet();
	}

	@Override
	//Resolve
	public void resolveForeignKeys(java.util.List<org.molgenis.omx.observ.ObservationSet> entities)  throws org.molgenis.framework.db.DatabaseException, java.text.ParseException
	{
		//create foreign key map for field 'partOfDataSet' to dataSet.id using Identifier)	
		//we will use a hash of the values to ensure that entities are only queried once	
		final java.util.Map<String, org.molgenis.framework.db.QueryRule> partOfDataSetRules = new java.util.LinkedHashMap<String, org.molgenis.framework.db.QueryRule>();
		//create all query rules	
		for(org.molgenis.omx.observ.ObservationSet object: entities)
		{
			//create xref/mref rule filtering DataSet on the label Identifier
			if(object.getPartOfDataSet_Id() == null && object.getPartOfDataSet_Identifier() != null)
			{
				Object label = object.getPartOfDataSet_Identifier();
				{
					org.molgenis.framework.db.QueryRule xrefFilter = new org.molgenis.framework.db.QueryRule("Identifier", org.molgenis.framework.db.QueryRule.Operator.EQUALS, label.toString());
					
					if(label != null && !partOfDataSetRules.containsKey(label))
					{
						partOfDataSetRules.put(""+label, xrefFilter);
						partOfDataSetRules.put(""+label+"_OR_", new org.molgenis.framework.db.QueryRule(org.molgenis.framework.db.QueryRule.Operator.OR));
					}
				}
			}		
		}

		//resolve foreign key field 'partOfDataSet' to dataSet.id using Identifier)
		final java.util.Map<String,Integer> partOfDataSet_Labels_to_IdMap = new java.util.TreeMap<String,Integer>();
		if(partOfDataSetRules.size() > 0)
		{		
		
			java.util.List<org.molgenis.omx.observ.DataSet> partOfDataSetList = null;
			try
			{
				partOfDataSetList = getDatabase().find(org.molgenis.omx.observ.DataSet.class, partOfDataSetRules.values().toArray(new org.molgenis.framework.db.QueryRule[partOfDataSetRules.values().size()]));
			}
			catch(Exception e)
			{
				// something went wrong while querying for this entities' name field
				// we assume it has no such field, which should have been checked earlier ofcourse
				// regardless, just quit the function now
				throw new org.molgenis.framework.db.DatabaseException(e);
			}
		
			for(org.molgenis.omx.observ.DataSet xref :  partOfDataSetList)
			{
				String key = "";
				key += 	xref.getIdentifier();
				
				partOfDataSet_Labels_to_IdMap.put(key, xref.getId());
			}
		}

		//update objects with the keys
		for(int i = 0; i < entities.size(); i++)
		{
			org.molgenis.omx.observ.ObservationSet object = entities.get(i);		
			//update object using label fields Identifier
			if(object.getPartOfDataSet_Id() == null )
			{
					String key = "";
					if(object.getPartOfDataSet_Identifier() != null)
						key += 	object.getPartOfDataSet_Identifier();
					
					if(!"".equals(key) && partOfDataSet_Labels_to_IdMap.get(key) == null) 
					{
						throw new org.molgenis.framework.db.DatabaseException("partOfDataSet_Identifier cannot be resolved: unknown xref='"+key+"'");
					}
					else
					{
						object.setPartOfDataSet_Id(partOfDataSet_Labels_to_IdMap.get(key));
					}
			}
						
		}
	}	
	
	@Override
	public org.molgenis.fieldtypes.FieldType getFieldType(String fieldName)
	{
			if("id".equalsIgnoreCase(fieldName) || "observationSet.id".equalsIgnoreCase(fieldName)) 
				return new org.molgenis.fieldtypes.IntField();
			if("partOfDataSet".equalsIgnoreCase(fieldName) || "observationSet.partOfDataSet".equalsIgnoreCase(fieldName)) 
				return new org.molgenis.fieldtypes.XrefField();
			if("time".equalsIgnoreCase(fieldName) || "observationSet.time".equalsIgnoreCase(fieldName)) 
				return new org.molgenis.fieldtypes.DatetimeField();
		return null;
	}		
	@Override
	public void prepareFileAttachements(java.util.List<org.molgenis.omx.observ.ObservationSet> entities, java.io.File baseDir) throws java.io.IOException
	{
	}

	@Override
	public boolean saveFileAttachements(java.util.List<org.molgenis.omx.observ.ObservationSet> entities, java.io.File baseDir) throws java.io.IOException
	{
		return false;
	}}
