/* File:        org.molgenis.omx/model/ObservedValue.java
 * Copyright:   GBIC 2000-2,013, all rights reserved
 * Date:        August 21, 2013
 * Template:	JpaMapperGen.java.ftl
 * generator:   org.molgenis.generators.db.JpaMapperGen 4.0.0-testing
 *
 * Jpa Entity Mapper, helper to add, delete and update entities
 * 
 * THIS FILE HAS BEEN GENERATED, PLEASE DO NOT EDIT!
 */

package org.molgenis.omx.observ.db;

@edu.umd.cs.findbugs.annotations.SuppressWarnings(value = "DLS_DEAD_LOCAL_STORE", justification = "Too much template code required to prevent warnings")
public class ObservedValueJpaMapper extends org.molgenis.framework.db.jpa.AbstractJpaMapper<org.molgenis.omx.observ.ObservedValue>
{
	private final static org.apache.log4j.Logger log = org.apache.log4j.Logger.getLogger(ObservedValueJpaMapper.class);

	public ObservedValueJpaMapper(org.molgenis.framework.db.Database db) 
	{
		super(db);
	}
	
	@Override
	public String createFindSqlInclRules(org.molgenis.framework.db.QueryRule[] rules) throws org.molgenis.framework.db.DatabaseException
	{
		return "SELECT ObservedValue.id"
			+", ObservedValue.ObservationSet"
			+", ObservedValue.Feature"
			+", ObservedValue.Value"
			//parent is SimpleTree(name='ObservationSet')
			+", xref_ObservationSet.id AS ObservationSet_Id"
			//parent is SimpleTree(name='Feature')
			+", xref_Feature.Identifier AS Feature_Identifier"
			//parent is SimpleTree(name='Value')
			+", xref_Value.id AS Value_Id"
			+" FROM ObservedValue "

			
			//label for ObservationSet=id
//path==ObservationSet. type==xref.
//path==ObservationSet_Id. type==int.
//in if path.value.type != "xref" && !pathlist?seq_contains(path.getParent().name)
		   	+" LEFT JOIN ObservationSet AS xref_ObservationSet " 
			+" ON xref_ObservationSet.id = ObservedValue.ObservationSet"
			
			//label for Feature=Identifier
//path==Feature. type==xref.
//path==Feature_Identifier. type==string.
//in if path.value.type != "xref" && !pathlist?seq_contains(path.getParent().name)
		   	+" LEFT JOIN Characteristic AS xref_Feature " 
			+" ON xref_Feature.id = ObservedValue.Feature"
			
			//label for Value=id
//path==Value. type==xref.
//path==Value_Id. type==int.
//in if path.value.type != "xref" && !pathlist?seq_contains(path.getParent().name)
		   	+" LEFT JOIN Value AS xref_Value " 
			+" ON xref_Value.id = ObservedValue.Value"
;
	}	

	/** This method first saves the objects that are being refered to by entity, 
	then the entity itself and 
	finally the objects that refer to this object*/
    public void create(org.molgenis.omx.observ.ObservedValue entity) throws org.molgenis.framework.db.DatabaseException {
        try {


			//check if the object refered by 'ObservationSet' is known in the databse
			if(entity.getObservationSet() != null)
			{
				//if object has been added as xref, but not yet stored (has no id) -> add the refered object
				if(entity.getObservationSet().getIdValue() == null)
					new org.molgenis.omx.observ.db.ObservationSetJpaMapper(getDatabase()).create(entity.getObservationSet());
				//if object has id (so is stored) but not in this em -> retrieve proper reference reference
				else if (!getEntityManager().contains(entity.getObservationSet()) && entity.getObservationSet().getIdValue() != null)
					entity.setObservationSet(getEntityManager().getReference(org.molgenis.omx.observ.ObservationSet.class, entity.getObservationSet().getIdValue()));
			} else { //object is reference by xref	
				if(entity.getObservationSet_Id() != null) {
					entity.setObservationSet((org.molgenis.omx.observ.ObservationSet)getEntityManager().find(org.molgenis.omx.observ.ObservationSet.class, entity.getObservationSet_Id()));
				}
			}
			//check if the object refered by 'Feature' is known in the databse
			if(entity.getFeature() != null)
			{
				//if object has been added as xref, but not yet stored (has no id) -> add the refered object
				if(entity.getFeature().getIdValue() == null)
					new org.molgenis.omx.observ.db.ObservableFeatureJpaMapper(getDatabase()).create(entity.getFeature());
				//if object has id (so is stored) but not in this em -> retrieve proper reference reference
				else if (!getEntityManager().contains(entity.getFeature()) && entity.getFeature().getIdValue() != null)
					entity.setFeature(getEntityManager().getReference(org.molgenis.omx.observ.ObservableFeature.class, entity.getFeature().getIdValue()));
			} else { //object is reference by xref	
				if(entity.getFeature_Id() != null) {
					entity.setFeature((org.molgenis.omx.observ.ObservableFeature)getEntityManager().find(org.molgenis.omx.observ.ObservableFeature.class, entity.getFeature_Id()));
				}
			}
			//check if the object refered by 'Value' is known in the databse
			if(entity.getValue() != null)
			{
				//if object has been added as xref, but not yet stored (has no id) -> add the refered object
				if(entity.getValue().getIdValue() == null)
					new org.molgenis.omx.observ.value.db.ValueJpaMapper(getDatabase()).create(entity.getValue());
				//if object has id (so is stored) but not in this em -> retrieve proper reference reference
				else if (!getEntityManager().contains(entity.getValue()) && entity.getValue().getIdValue() != null)
					entity.setValue(getEntityManager().getReference(org.molgenis.omx.observ.value.Value.class, entity.getValue().getIdValue()));
			} else { //object is reference by xref	
				if(entity.getValue_Id() != null) {
					entity.setValue((org.molgenis.omx.observ.value.Value)getEntityManager().find(org.molgenis.omx.observ.value.Value.class, entity.getValue_Id()));
				}
			}

			//prevents uncontrolled recursion call of create (stack overflow)
          
          if(entity.getIdValue() != null) {
            entity = getEntityManager().merge(entity);            
          } else {
            getEntityManager().persist(entity);
          }
//inverse association relation

        } catch (Exception ex) {
            try {
				getEntityManager().getTransaction().rollback();
            } catch (Exception re) {
                throw new org.molgenis.framework.db.DatabaseException("An error occurred attempting to roll back the transaction: "+re.getMessage());
            }
            throw new org.molgenis.framework.db.DatabaseException(ex);
        }
    }

	public void destroy(org.molgenis.omx.observ.ObservedValue observedValue) throws org.molgenis.framework.db.DatabaseException {
		try {
			try {
				observedValue = getEntityManager().getReference(org.molgenis.omx.observ.ObservedValue.class, observedValue.getIdValue());
			} catch (javax.persistence.EntityNotFoundException enfe) {
				throw new org.molgenis.framework.db.DatabaseException("The observedValue with id " + observedValue.getIdField().toString() + " no longer exists: " + enfe.getMessage());
			}

			getEntityManager().remove(observedValue);
		} catch (Exception ex) {
			try {
				getEntityManager().getTransaction().rollback();
			} catch (Exception re) {
				throw new org.molgenis.framework.db.DatabaseException("An error occurred attempting to roll back the transaction: "+re.getMessage());
			}
			throw new org.molgenis.framework.db.DatabaseException(ex);
		} 
	}


	public void edit(org.molgenis.omx.observ.ObservedValue observedValue) throws org.molgenis.framework.db.DatabaseException {
		try {



			//1
			org.molgenis.omx.observ.ObservationSet observationSetNew = observedValue.getObservationSet();

			if (observationSetNew == null) { //object is reference by xref		
                            if(observedValue.getObservationSet_Id() != null) {
                                observedValue.setObservationSet((org.molgenis.omx.observ.ObservationSet)getEntityManager().find(org.molgenis.omx.observ.ObservationSet.class, observedValue.getObservationSet_Id()));
                            }
			}


			//4
			org.molgenis.omx.observ.ObservableFeature featureNew = observedValue.getFeature();

			if (featureNew == null) { //object is reference by xref		
                            if(observedValue.getFeature_Id() != null) {
                                observedValue.setFeature((org.molgenis.omx.observ.ObservableFeature)getEntityManager().find(org.molgenis.omx.observ.ObservableFeature.class, observedValue.getFeature_Id()));
                            }
			}


			//1
			org.molgenis.omx.observ.value.Value valueNew = observedValue.getValue();

			if (valueNew == null) { //object is reference by xref		
                            if(observedValue.getValue_Id() != null) {
                                observedValue.setValue((org.molgenis.omx.observ.value.Value)getEntityManager().find(org.molgenis.omx.observ.value.Value.class, observedValue.getValue_Id()));
                            }
			}
			if(!getEntityManager().contains(observedValue)) {
				observedValue = getEntityManager().merge(observedValue);
			}
			



		} catch (Exception ex) {
			try {
				getEntityManager().getTransaction().rollback();
			} catch (Exception re) {
				throw new org.molgenis.framework.db.DatabaseException("An error occurred attempting to roll back the transaction: " + re.getMessage());
			}
			throw new org.molgenis.framework.db.DatabaseException(ex);
		} 
	}

	@Override
	public int executeAdd(java.util.List<? extends org.molgenis.omx.observ.ObservedValue> entities) throws org.molgenis.framework.db.DatabaseException
	{	
		int count = 0;
		
		try 
		{
			for (org.molgenis.omx.observ.ObservedValue observedValue : entities) 
			{
				create(observedValue);
				++count;
			}
		}
		catch (Exception ex) 
		{
            throw new org.molgenis.framework.db.DatabaseException(ex);
        }
		return count;
	}

	@Override
	public int executeUpdate(java.util.List<? extends org.molgenis.omx.observ.ObservedValue> entities) throws org.molgenis.framework.db.DatabaseException
	{
		int count = 0;

		try
		{
			for (org.molgenis.omx.observ.ObservedValue observedValue : entities) 
			{
				edit(observedValue);
				++count;
			} 
			return count;
		}
		catch (Exception ex) 
		{
            throw new org.molgenis.framework.db.DatabaseException(ex);
        }		
	}

	@Override
	public int executeRemove(java.util.List<? extends org.molgenis.omx.observ.ObservedValue> entities) throws org.molgenis.framework.db.DatabaseException
	{
		int count = 0;		
		try 
		{
			for (org.molgenis.omx.observ.ObservedValue observedValue : entities) 
			{
				destroy(observedValue);
				++count;
			}
		} 
		catch (Exception ex) 
		{
            throw new org.molgenis.framework.db.DatabaseException(ex);
        }
		return count;
	}
	
	@Override
	public String getTableFieldName(String fieldName)
	{
		if("id".equalsIgnoreCase(fieldName)) return "id";
		if("ObservedValue_id".equalsIgnoreCase(fieldName)) return "id";
		if("ObservationSet".equalsIgnoreCase(fieldName)) return "ObservationSet";
		if("ObservedValue_ObservationSet".equalsIgnoreCase(fieldName)) return "ObservationSet";
		if("Feature".equalsIgnoreCase(fieldName)) return "Feature";
		if("ObservedValue_Feature".equalsIgnoreCase(fieldName)) return "Feature";
		if("Value".equalsIgnoreCase(fieldName)) return "Value";
		if("ObservedValue_Value".equalsIgnoreCase(fieldName)) return "Value";
		if("ObservationSet_id".equalsIgnoreCase(fieldName)) return "ObservationSet";
		if("ObservedValue_ObservationSet_id".equalsIgnoreCase(fieldName)) return "ObservationSet";
		if("ObservationSet_Id".equalsIgnoreCase(fieldName)) return "ObservationSet.id";	
		if("ObservedValue_ObservationSet_Id".equalsIgnoreCase(fieldName)) return "ObservationSet.id";
		if("Feature_id".equalsIgnoreCase(fieldName)) return "Feature";
		if("ObservedValue_Feature_id".equalsIgnoreCase(fieldName)) return "Feature";
		if("Feature_Identifier".equalsIgnoreCase(fieldName)) return "Feature.Identifier";	
		if("ObservedValue_Feature_Identifier".equalsIgnoreCase(fieldName)) return "Feature.Identifier";
		if("Value_id".equalsIgnoreCase(fieldName)) return "Value";
		if("ObservedValue_Value_id".equalsIgnoreCase(fieldName)) return "Value";
		if("Value_Id".equalsIgnoreCase(fieldName)) return "Value.id";	
		if("ObservedValue_Value_Id".equalsIgnoreCase(fieldName)) return "Value.id";
		return fieldName;
	}
	
	/**
	 * Return EMPTY list of given allocated size
	 *
	 * @param i initial capacity of returned EMPTY list
	 * @return an EMPTY list with initial capacity given by size
	 */
	@Override
	public java.util.List<org.molgenis.omx.observ.ObservedValue> createList(int size)
	{
		return new java.util.ArrayList<org.molgenis.omx.observ.ObservedValue>(size);
	}			

	@Override
	public org.molgenis.omx.observ.ObservedValue create()
	{
		return new org.molgenis.omx.observ.ObservedValue();
	}

	@Override
	//Resolve
	public void resolveForeignKeys(java.util.List<org.molgenis.omx.observ.ObservedValue> entities)  throws org.molgenis.framework.db.DatabaseException, java.text.ParseException
	{
		//create foreign key map for field 'feature' to observableFeature.id using Identifier)	
		//we will use a hash of the values to ensure that entities are only queried once	
		final java.util.Map<String, org.molgenis.framework.db.QueryRule> featureRules = new java.util.LinkedHashMap<String, org.molgenis.framework.db.QueryRule>();
		//create all query rules	
		for(org.molgenis.omx.observ.ObservedValue object: entities)
		{
			//create xref/mref rule filtering ObservableFeature on the label Identifier
			if(object.getFeature_Id() == null && object.getFeature_Identifier() != null)
			{
				Object label = object.getFeature_Identifier();
				{
					org.molgenis.framework.db.QueryRule xrefFilter = new org.molgenis.framework.db.QueryRule("Identifier", org.molgenis.framework.db.QueryRule.Operator.EQUALS, label.toString());
					
					if(label != null && !featureRules.containsKey(label))
					{
						featureRules.put(""+label, xrefFilter);
						featureRules.put(""+label+"_OR_", new org.molgenis.framework.db.QueryRule(org.molgenis.framework.db.QueryRule.Operator.OR));
					}
				}
			}		
		}

		//resolve foreign key field 'feature' to observableFeature.id using Identifier)
		final java.util.Map<String,Integer> feature_Labels_to_IdMap = new java.util.TreeMap<String,Integer>();
		if(featureRules.size() > 0)
		{		
		
			java.util.List<org.molgenis.omx.observ.ObservableFeature> featureList = null;
			try
			{
				featureList = getDatabase().find(org.molgenis.omx.observ.ObservableFeature.class, featureRules.values().toArray(new org.molgenis.framework.db.QueryRule[featureRules.values().size()]));
			}
			catch(Exception e)
			{
				// something went wrong while querying for this entities' name field
				// we assume it has no such field, which should have been checked earlier ofcourse
				// regardless, just quit the function now
				throw new org.molgenis.framework.db.DatabaseException(e);
			}
		
			for(org.molgenis.omx.observ.ObservableFeature xref :  featureList)
			{
				String key = "";
				key += 	xref.getIdentifier();
				
				feature_Labels_to_IdMap.put(key, xref.getId());
			}
		}

		//update objects with the keys
		for(int i = 0; i < entities.size(); i++)
		{
			org.molgenis.omx.observ.ObservedValue object = entities.get(i);		
			//update object using label fields Identifier
			if(object.getFeature_Id() == null )
			{
					String key = "";
					if(object.getFeature_Identifier() != null)
						key += 	object.getFeature_Identifier();
					
					if(!"".equals(key) && feature_Labels_to_IdMap.get(key) == null) 
					{
						throw new org.molgenis.framework.db.DatabaseException("Feature_Identifier cannot be resolved: unknown xref='"+key+"'");
					}
					else
					{
						object.setFeature_Id(feature_Labels_to_IdMap.get(key));
					}
			}
						
		}
	}	
	
	@Override
	public org.molgenis.fieldtypes.FieldType getFieldType(String fieldName)
	{
			if("id".equalsIgnoreCase(fieldName) || "observedValue.id".equalsIgnoreCase(fieldName)) 
				return new org.molgenis.fieldtypes.IntField();
			if("observationSet".equalsIgnoreCase(fieldName) || "observedValue.observationSet".equalsIgnoreCase(fieldName)) 
				return new org.molgenis.fieldtypes.XrefField();
			if("feature".equalsIgnoreCase(fieldName) || "observedValue.feature".equalsIgnoreCase(fieldName)) 
				return new org.molgenis.fieldtypes.XrefField();
			if("value".equalsIgnoreCase(fieldName) || "observedValue.value".equalsIgnoreCase(fieldName)) 
				return new org.molgenis.fieldtypes.XrefField();
		return null;
	}		
	@Override
	public void prepareFileAttachements(java.util.List<org.molgenis.omx.observ.ObservedValue> entities, java.io.File baseDir) throws java.io.IOException
	{
	}

	@Override
	public boolean saveFileAttachements(java.util.List<org.molgenis.omx.observ.ObservedValue> entities, java.io.File baseDir) throws java.io.IOException
	{
		return false;
	}}
