/* File:        org.molgenis.omx/model/PanelSource.java
 * Copyright:   GBIC 2000-2,013, all rights reserved
 * Date:        August 21, 2013
 * Template:	JpaMapperGen.java.ftl
 * generator:   org.molgenis.generators.db.JpaMapperGen 4.0.0-testing
 *
 * Jpa Entity Mapper, helper to add, delete and update entities
 * 
 * THIS FILE HAS BEEN GENERATED, PLEASE DO NOT EDIT!
 */

package org.molgenis.omx.observ.target.db;

@edu.umd.cs.findbugs.annotations.SuppressWarnings(value = "DLS_DEAD_LOCAL_STORE", justification = "Too much template code required to prevent warnings")
public class PanelSourceJpaMapper extends org.molgenis.framework.db.jpa.AbstractJpaMapper<org.molgenis.omx.observ.target.PanelSource>
{
	private final static org.apache.log4j.Logger log = org.apache.log4j.Logger.getLogger(PanelSourceJpaMapper.class);

	public PanelSourceJpaMapper(org.molgenis.framework.db.Database db) 
	{
		super(db);
	}
	
	@Override
	public String createFindSqlInclRules(org.molgenis.framework.db.QueryRule[] rules) throws org.molgenis.framework.db.DatabaseException
	{
		return "SELECT PanelSource.id"
			+", PanelSource.CurrentPanel"
			+", PanelSource.SourcePanel"
			+", PanelSource.NumberOfIndividuals"
			+", PanelSource.SelectionCriteria"
			//parent is SimpleTree(name='CurrentPanel')
			+", xref_CurrentPanel.Identifier AS CurrentPanel_Identifier"
			//parent is SimpleTree(name='SourcePanel')
			+", xref_SourcePanel.Identifier AS SourcePanel_Identifier"
			+" FROM PanelSource "

			
			//label for CurrentPanel=Identifier
//path==CurrentPanel. type==xref.
//path==CurrentPanel_Identifier. type==string.
//in if path.value.type != "xref" && !pathlist?seq_contains(path.getParent().name)
		   	+" LEFT JOIN Characteristic AS xref_CurrentPanel " 
			+" ON xref_CurrentPanel.id = PanelSource.CurrentPanel"
			
			//label for SourcePanel=Identifier
//path==SourcePanel. type==xref.
//path==SourcePanel_Identifier. type==string.
//in if path.value.type != "xref" && !pathlist?seq_contains(path.getParent().name)
		   	+" LEFT JOIN Characteristic AS xref_SourcePanel " 
			+" ON xref_SourcePanel.id = PanelSource.SourcePanel"
;
	}	

	/** This method first saves the objects that are being refered to by entity, 
	then the entity itself and 
	finally the objects that refer to this object*/
    public void create(org.molgenis.omx.observ.target.PanelSource entity) throws org.molgenis.framework.db.DatabaseException {
        try {


			//check if the object refered by 'CurrentPanel' is known in the databse
			if(entity.getCurrentPanel() != null)
			{
				//if object has been added as xref, but not yet stored (has no id) -> add the refered object
				if(entity.getCurrentPanel().getIdValue() == null)
					new org.molgenis.omx.observ.target.db.PanelJpaMapper(getDatabase()).create(entity.getCurrentPanel());
				//if object has id (so is stored) but not in this em -> retrieve proper reference reference
				else if (!getEntityManager().contains(entity.getCurrentPanel()) && entity.getCurrentPanel().getIdValue() != null)
					entity.setCurrentPanel(getEntityManager().getReference(org.molgenis.omx.observ.target.Panel.class, entity.getCurrentPanel().getIdValue()));
			} else { //object is reference by xref	
				if(entity.getCurrentPanel_Id() != null) {
					entity.setCurrentPanel((org.molgenis.omx.observ.target.Panel)getEntityManager().find(org.molgenis.omx.observ.target.Panel.class, entity.getCurrentPanel_Id()));
				}
			}
			//check if the object refered by 'SourcePanel' is known in the databse
			if(entity.getSourcePanel() != null)
			{
				//if object has been added as xref, but not yet stored (has no id) -> add the refered object
				if(entity.getSourcePanel().getIdValue() == null)
					new org.molgenis.omx.observ.target.db.PanelJpaMapper(getDatabase()).create(entity.getSourcePanel());
				//if object has id (so is stored) but not in this em -> retrieve proper reference reference
				else if (!getEntityManager().contains(entity.getSourcePanel()) && entity.getSourcePanel().getIdValue() != null)
					entity.setSourcePanel(getEntityManager().getReference(org.molgenis.omx.observ.target.Panel.class, entity.getSourcePanel().getIdValue()));
			} else { //object is reference by xref	
				if(entity.getSourcePanel_Id() != null) {
					entity.setSourcePanel((org.molgenis.omx.observ.target.Panel)getEntityManager().find(org.molgenis.omx.observ.target.Panel.class, entity.getSourcePanel_Id()));
				}
			}

			//prevents uncontrolled recursion call of create (stack overflow)
          
          if(entity.getIdValue() != null) {
            entity = getEntityManager().merge(entity);            
          } else {
            getEntityManager().persist(entity);
          }
//inverse association relation

        } catch (Exception ex) {
            try {
				getEntityManager().getTransaction().rollback();
            } catch (Exception re) {
                throw new org.molgenis.framework.db.DatabaseException("An error occurred attempting to roll back the transaction: "+re.getMessage());
            }
            throw new org.molgenis.framework.db.DatabaseException(ex);
        }
    }

	public void destroy(org.molgenis.omx.observ.target.PanelSource panelSource) throws org.molgenis.framework.db.DatabaseException {
		try {
			try {
				panelSource = getEntityManager().getReference(org.molgenis.omx.observ.target.PanelSource.class, panelSource.getIdValue());
			} catch (javax.persistence.EntityNotFoundException enfe) {
				throw new org.molgenis.framework.db.DatabaseException("The panelSource with id " + panelSource.getIdField().toString() + " no longer exists: " + enfe.getMessage());
			}

			getEntityManager().remove(panelSource);
		} catch (Exception ex) {
			try {
				getEntityManager().getTransaction().rollback();
			} catch (Exception re) {
				throw new org.molgenis.framework.db.DatabaseException("An error occurred attempting to roll back the transaction: "+re.getMessage());
			}
			throw new org.molgenis.framework.db.DatabaseException(ex);
		} 
	}


	public void edit(org.molgenis.omx.observ.target.PanelSource panelSource) throws org.molgenis.framework.db.DatabaseException {
		try {



			//3
			org.molgenis.omx.observ.target.Panel currentPanelNew = panelSource.getCurrentPanel();

			if (currentPanelNew == null) { //object is reference by xref		
                            if(panelSource.getCurrentPanel_Id() != null) {
                                panelSource.setCurrentPanel((org.molgenis.omx.observ.target.Panel)getEntityManager().find(org.molgenis.omx.observ.target.Panel.class, panelSource.getCurrentPanel_Id()));
                            }
			}


			//3
			org.molgenis.omx.observ.target.Panel sourcePanelNew = panelSource.getSourcePanel();

			if (sourcePanelNew == null) { //object is reference by xref		
                            if(panelSource.getSourcePanel_Id() != null) {
                                panelSource.setSourcePanel((org.molgenis.omx.observ.target.Panel)getEntityManager().find(org.molgenis.omx.observ.target.Panel.class, panelSource.getSourcePanel_Id()));
                            }
			}


			if(!getEntityManager().contains(panelSource)) {
				panelSource = getEntityManager().merge(panelSource);
			}
			


		} catch (Exception ex) {
			try {
				getEntityManager().getTransaction().rollback();
			} catch (Exception re) {
				throw new org.molgenis.framework.db.DatabaseException("An error occurred attempting to roll back the transaction: " + re.getMessage());
			}
			throw new org.molgenis.framework.db.DatabaseException(ex);
		} 
	}

	@Override
	public int executeAdd(java.util.List<? extends org.molgenis.omx.observ.target.PanelSource> entities) throws org.molgenis.framework.db.DatabaseException
	{	
		int count = 0;
		
		try 
		{
			for (org.molgenis.omx.observ.target.PanelSource panelSource : entities) 
			{
				create(panelSource);
				++count;
			}
		}
		catch (Exception ex) 
		{
            throw new org.molgenis.framework.db.DatabaseException(ex);
        }
		return count;
	}

	@Override
	public int executeUpdate(java.util.List<? extends org.molgenis.omx.observ.target.PanelSource> entities) throws org.molgenis.framework.db.DatabaseException
	{
		int count = 0;

		try
		{
			for (org.molgenis.omx.observ.target.PanelSource panelSource : entities) 
			{
				edit(panelSource);
				++count;
			} 
			return count;
		}
		catch (Exception ex) 
		{
            throw new org.molgenis.framework.db.DatabaseException(ex);
        }		
	}

	@Override
	public int executeRemove(java.util.List<? extends org.molgenis.omx.observ.target.PanelSource> entities) throws org.molgenis.framework.db.DatabaseException
	{
		int count = 0;		
		try 
		{
			for (org.molgenis.omx.observ.target.PanelSource panelSource : entities) 
			{
				destroy(panelSource);
				++count;
			}
		} 
		catch (Exception ex) 
		{
            throw new org.molgenis.framework.db.DatabaseException(ex);
        }
		return count;
	}
	
	@Override
	public String getTableFieldName(String fieldName)
	{
		if("id".equalsIgnoreCase(fieldName)) return "id";
		if("PanelSource_id".equalsIgnoreCase(fieldName)) return "id";
		if("CurrentPanel".equalsIgnoreCase(fieldName)) return "CurrentPanel";
		if("PanelSource_CurrentPanel".equalsIgnoreCase(fieldName)) return "CurrentPanel";
		if("SourcePanel".equalsIgnoreCase(fieldName)) return "SourcePanel";
		if("PanelSource_SourcePanel".equalsIgnoreCase(fieldName)) return "SourcePanel";
		if("NumberOfIndividuals".equalsIgnoreCase(fieldName)) return "NumberOfIndividuals";
		if("PanelSource_NumberOfIndividuals".equalsIgnoreCase(fieldName)) return "NumberOfIndividuals";
		if("SelectionCriteria".equalsIgnoreCase(fieldName)) return "SelectionCriteria";
		if("PanelSource_SelectionCriteria".equalsIgnoreCase(fieldName)) return "SelectionCriteria";
		if("CurrentPanel_id".equalsIgnoreCase(fieldName)) return "CurrentPanel";
		if("PanelSource_CurrentPanel_id".equalsIgnoreCase(fieldName)) return "CurrentPanel";
		if("CurrentPanel_Identifier".equalsIgnoreCase(fieldName)) return "CurrentPanel.Identifier";	
		if("PanelSource_CurrentPanel_Identifier".equalsIgnoreCase(fieldName)) return "CurrentPanel.Identifier";
		if("SourcePanel_id".equalsIgnoreCase(fieldName)) return "SourcePanel";
		if("PanelSource_SourcePanel_id".equalsIgnoreCase(fieldName)) return "SourcePanel";
		if("SourcePanel_Identifier".equalsIgnoreCase(fieldName)) return "SourcePanel.Identifier";	
		if("PanelSource_SourcePanel_Identifier".equalsIgnoreCase(fieldName)) return "SourcePanel.Identifier";
		return fieldName;
	}
	
	/**
	 * Return EMPTY list of given allocated size
	 *
	 * @param i initial capacity of returned EMPTY list
	 * @return an EMPTY list with initial capacity given by size
	 */
	@Override
	public java.util.List<org.molgenis.omx.observ.target.PanelSource> createList(int size)
	{
		return new java.util.ArrayList<org.molgenis.omx.observ.target.PanelSource>(size);
	}			

	@Override
	public org.molgenis.omx.observ.target.PanelSource create()
	{
		return new org.molgenis.omx.observ.target.PanelSource();
	}

	@Override
	//Resolve
	public void resolveForeignKeys(java.util.List<org.molgenis.omx.observ.target.PanelSource> entities)  throws org.molgenis.framework.db.DatabaseException, java.text.ParseException
	{
		//create foreign key map for field 'currentPanel' to panel.id using Identifier)	
		//we will use a hash of the values to ensure that entities are only queried once	
		final java.util.Map<String, org.molgenis.framework.db.QueryRule> currentPanelRules = new java.util.LinkedHashMap<String, org.molgenis.framework.db.QueryRule>();
		//create foreign key map for field 'sourcePanel' to panel.id using Identifier)	
		//we will use a hash of the values to ensure that entities are only queried once	
		final java.util.Map<String, org.molgenis.framework.db.QueryRule> sourcePanelRules = new java.util.LinkedHashMap<String, org.molgenis.framework.db.QueryRule>();
		//create all query rules	
		for(org.molgenis.omx.observ.target.PanelSource object: entities)
		{
			//create xref/mref rule filtering Panel on the label Identifier
			if(object.getCurrentPanel_Id() == null && object.getCurrentPanel_Identifier() != null)
			{
				Object label = object.getCurrentPanel_Identifier();
				{
					org.molgenis.framework.db.QueryRule xrefFilter = new org.molgenis.framework.db.QueryRule("Identifier", org.molgenis.framework.db.QueryRule.Operator.EQUALS, label.toString());
					
					if(label != null && !currentPanelRules.containsKey(label))
					{
						currentPanelRules.put(""+label, xrefFilter);
						currentPanelRules.put(""+label+"_OR_", new org.molgenis.framework.db.QueryRule(org.molgenis.framework.db.QueryRule.Operator.OR));
					}
				}
			}		
			//create xref/mref rule filtering Panel on the label Identifier
			if(object.getSourcePanel_Id() == null && object.getSourcePanel_Identifier() != null)
			{
				Object label = object.getSourcePanel_Identifier();
				{
					org.molgenis.framework.db.QueryRule xrefFilter = new org.molgenis.framework.db.QueryRule("Identifier", org.molgenis.framework.db.QueryRule.Operator.EQUALS, label.toString());
					
					if(label != null && !sourcePanelRules.containsKey(label))
					{
						sourcePanelRules.put(""+label, xrefFilter);
						sourcePanelRules.put(""+label+"_OR_", new org.molgenis.framework.db.QueryRule(org.molgenis.framework.db.QueryRule.Operator.OR));
					}
				}
			}		
		}

		//resolve foreign key field 'currentPanel' to panel.id using Identifier)
		final java.util.Map<String,Integer> currentPanel_Labels_to_IdMap = new java.util.TreeMap<String,Integer>();
		if(currentPanelRules.size() > 0)
		{		
		
			java.util.List<org.molgenis.omx.observ.target.Panel> currentPanelList = null;
			try
			{
				currentPanelList = getDatabase().find(org.molgenis.omx.observ.target.Panel.class, currentPanelRules.values().toArray(new org.molgenis.framework.db.QueryRule[currentPanelRules.values().size()]));
			}
			catch(Exception e)
			{
				// something went wrong while querying for this entities' name field
				// we assume it has no such field, which should have been checked earlier ofcourse
				// regardless, just quit the function now
				throw new org.molgenis.framework.db.DatabaseException(e);
			}
		
			for(org.molgenis.omx.observ.target.Panel xref :  currentPanelList)
			{
				String key = "";
				key += 	xref.getIdentifier();
				
				currentPanel_Labels_to_IdMap.put(key, xref.getId());
			}
		}
		//resolve foreign key field 'sourcePanel' to panel.id using Identifier)
		final java.util.Map<String,Integer> sourcePanel_Labels_to_IdMap = new java.util.TreeMap<String,Integer>();
		if(sourcePanelRules.size() > 0)
		{		
		
			java.util.List<org.molgenis.omx.observ.target.Panel> sourcePanelList = null;
			try
			{
				sourcePanelList = getDatabase().find(org.molgenis.omx.observ.target.Panel.class, sourcePanelRules.values().toArray(new org.molgenis.framework.db.QueryRule[sourcePanelRules.values().size()]));
			}
			catch(Exception e)
			{
				// something went wrong while querying for this entities' name field
				// we assume it has no such field, which should have been checked earlier ofcourse
				// regardless, just quit the function now
				throw new org.molgenis.framework.db.DatabaseException(e);
			}
		
			for(org.molgenis.omx.observ.target.Panel xref :  sourcePanelList)
			{
				String key = "";
				key += 	xref.getIdentifier();
				
				sourcePanel_Labels_to_IdMap.put(key, xref.getId());
			}
		}

		//update objects with the keys
		for(int i = 0; i < entities.size(); i++)
		{
			org.molgenis.omx.observ.target.PanelSource object = entities.get(i);		
			//update object using label fields Identifier
			if(object.getCurrentPanel_Id() == null )
			{
					String key = "";
					if(object.getCurrentPanel_Identifier() != null)
						key += 	object.getCurrentPanel_Identifier();
					
					if(!"".equals(key) && currentPanel_Labels_to_IdMap.get(key) == null) 
					{
						throw new org.molgenis.framework.db.DatabaseException("CurrentPanel_Identifier cannot be resolved: unknown xref='"+key+"'");
					}
					else
					{
						object.setCurrentPanel_Id(currentPanel_Labels_to_IdMap.get(key));
					}
			}
			//update object using label fields Identifier
			if(object.getSourcePanel_Id() == null )
			{
					String key = "";
					if(object.getSourcePanel_Identifier() != null)
						key += 	object.getSourcePanel_Identifier();
					
					if(!"".equals(key) && sourcePanel_Labels_to_IdMap.get(key) == null) 
					{
						throw new org.molgenis.framework.db.DatabaseException("SourcePanel_Identifier cannot be resolved: unknown xref='"+key+"'");
					}
					else
					{
						object.setSourcePanel_Id(sourcePanel_Labels_to_IdMap.get(key));
					}
			}
						
		}
	}	
	
	@Override
	public org.molgenis.fieldtypes.FieldType getFieldType(String fieldName)
	{
			if("id".equalsIgnoreCase(fieldName) || "panelSource.id".equalsIgnoreCase(fieldName)) 
				return new org.molgenis.fieldtypes.IntField();
			if("currentPanel".equalsIgnoreCase(fieldName) || "panelSource.currentPanel".equalsIgnoreCase(fieldName)) 
				return new org.molgenis.fieldtypes.XrefField();
			if("sourcePanel".equalsIgnoreCase(fieldName) || "panelSource.sourcePanel".equalsIgnoreCase(fieldName)) 
				return new org.molgenis.fieldtypes.XrefField();
			if("numberOfIndividuals".equalsIgnoreCase(fieldName) || "panelSource.numberOfIndividuals".equalsIgnoreCase(fieldName)) 
				return new org.molgenis.fieldtypes.IntField();
			if("selectionCriteria".equalsIgnoreCase(fieldName) || "panelSource.selectionCriteria".equalsIgnoreCase(fieldName)) 
				return new org.molgenis.fieldtypes.TextField();
		return null;
	}		
	@Override
	public void prepareFileAttachements(java.util.List<org.molgenis.omx.observ.target.PanelSource> entities, java.io.File baseDir) throws java.io.IOException
	{
	}

	@Override
	public boolean saveFileAttachements(java.util.List<org.molgenis.omx.observ.target.PanelSource> entities, java.io.File baseDir) throws java.io.IOException
	{
		return false;
	}}
